﻿/* AUTEUR : Jean-Luc Leloire
sous licence Creative Commons by-nc-sa 4.0 International
 */
/*Widget est un plugin permettant d'ajouter des widgets à un canvas style="background:yellow" 
/* APPEL : maVariable=new grafWidgets(canvas);
	où canvas est le canvas où seront dessinés les widgets.
*/

/*
//pour lier le css associé au plugin 
var cssId = 'grafWidgetsCss'; 
	if (!document.getElementById(cssId))
	{
		var head  = document.getElementsByTagName('head')[0];
		var link  = document.createElement('link');
		link.id   = cssId;
		link.rel  = 'stylesheet';
		link.type = 'text/css';
		link.href = 'styles/grafWidgets.css';
		link.media = 'all';
		head.appendChild(link);
	};
 */






 //pour indiquer le chemin où sont rangés les images et les polices
 //chemin site caen
/*var cheminJPG="http://physique-chimie.discip.ac-caen.fr/sites/physique-chimie.discip.ac-caen.fr/IMG/jpg/";
 var cheminPNG="http://physique-chimie.discip.ac-caen.fr/sites/physique-chimie.discip.ac-caen.fr/IMG/png/";
 var cheminTTF="http://physique-chimie.discip.ac-caen.fr/sites/physique-chimie.discip.ac-caen.fr/IMG/ttf/";*/
 //chemin perso
 var cheminJPG="";
 var cheminPNG="../grafwidgets/";
 var cheminTTF="../grafwidgets/";
 
 







 
//TODO touch pour écran tactile
/*		
	
//détection du point cliqué à la souris
function pointXY(e) {
	try{
		var id =e.target.id;
		var XYrect = document.getElementById(id).getBoundingClientRect();
		if (e.clientX || e.clientY) {
		var valX=e.clientX-XYrect.left;
		var valY=e.clientY-XYrect.top;
		}
		else if (e.targetTouches.length == 1) {
		// pour Android
		var touch = e.targetTouches[0];
		var valX = touch.pageX-this.canvas.offsetLeft;
		var valY = touch.pageY-this.canvas.offsetTop;
		} else {
			var valX = 0;
			var valX = 0;
		}
		return( { x : valX, y : valY } );
	}
	catch (e) {
	// les instructions utilisées pour gérer les exceptions
		console.log(e); 
	}
}
*/
//pour les conversions entre degré et radians
	var rad2Deg=180/Math.PI;
	var deg2Rad=Math.PI/180;
	//les fonctions trigonométriques en degré
	function sind(x){
		return Math.sin(x*deg2Rad);
	};	
	function cosd(x){
		return Math.cos(x*deg2Rad);
	};	
	function tand(x){
		return Math.tan(x*deg2Rad);
	};
	function asind(x){
		return Math.asin(x)*rad2Deg;
	};	
	function acosd(x){
		return Math.acos(x)*rad2Deg;
	};	
	function atand(x){
		return Math.atan(x)*rad2Deg;
	};
	function atan2d(y,x){
		return Math.atan2(y,x)*rad2Deg;
	};
	//réduction d'un angle entre 0 et 360°
	function rev(x){
		return x-Math.floor(x/360)*360;
	};
	//convertit les coordonnées d'un vecteur en sa direction angulaire en degré 
	function coordpolaire(x,y){
		if (x>0&&y>=0){return atand(y/x)};
		if (x>0&&y<0){return atand(y/x)+360};//+2*Math.PI};
		if (x<0){return atand(y/x)+180};//+Math.PI};
		if (x==0&&y>0){return 90};//Math.PI/2};
		if (x==0&&y<0){return 270};//3*Math.PI/2};
	};	



//le canvas qui contiendra tous les widgets
//initialisation du canvas
function grafWidgets(canvas) {
	this.canvas = canvas;
	this.width = canvas.width;
	this.height = canvas.height;
	this.ctx = canvas.getContext('2d');
	//tableau des widget mis dans le canvas
	this.widgets=[];
	//le canvas sera redessiné si false
	this.actualise = false; 
	// mémorise le widget sélectionné
	this.selection = null;
	// on mémorise un contrôle qui aurait le focus
	this.focus=null;
	//on mémorise un contrôle qui serait over
	this.over=null;
	//on memorise le contrôle qui peut avoir le drag
	this.drag=null;
	//memorisation du bouton de la souris enfoncé : par défaut le gauche
	this.bouton=0;
	//autorise le drag & drop si true
	this.dragging = true;
	//offset du déplacement du widget drag
	this.dragOffset ={x:0,y:0}  ;
	//les fonctions à surcharger pour dessiner le fond et le premier plan du canvas (les contröle seront entre les deux)
	this.dessinefond=function(){};
	this.dessinePP=function(){};
	this.xc=10;
	this.yc=this.height-10;
	this.affC=false;
	this.txtcolor="yellow";
	this.shadowcolor="rgba(0,0,0,0.5)";
	this.echelle=1;
	this.tailleAuto=true;
	this.adpaterALaTailleDeLaFenetre=function (){
		if (this.tailleAuto){
			var largeur = canvas.parentNode.clientWidth;
			canvas.parentElement.style.height=largeur/canvas.width*canvas.height;
			hauteur = document.documentElement.clientHeight;
			this.echelle=Math.min(largeur/canvas.width,hauteur/canvas.height);
			this.canvas.style.width=s.width*s.echelle+"px";
		}
	};
	
	
	this.dessineC=function(){
		if (this.affC) {
			with(this.ctx){
				beginPath();
				font = '15px Arial';
				shadowOffsetX = 4;
				shadowOffsetY = 4;
				shadowBlur = 4;	
				shadowColor   = this.shadowcolor;
				fillStyle=this.txtcolor;
				fillText(this.cc,this.xc,this.yc);
				shadowOffsetX = 0;
				shadowOffsetY = 0;
				shadowBlur = 0;	
				shadowColor   = "rgba(0, 0, 0, 0)";
				closePath();
			}
		}	
	};
	this.deC=function(cc){
		function deC(cPt){
		if (cPt > 0xFFFF){
			cPt -= 0x10000;
			return String.fromCharCode(0xD800 + (cPt >> 10),0xDC00 + (cPt & 0x3FF));
			}
		return String.fromCharCode(cPt);
		}
		if (cc!="")this.affc=true;
		this.cc=""
		for (var i=0;i<cc.length;i++){
			this.cc=this.cc+deC(cc[i]);
		}
	}
	
	
	
	//closure pour les événements
	var monCanvas=this;
	  
	//supprime la selection de text par double click sur canvas
	//this.canvas.addEventListener('selectstart', function(e) { e.preventDefault(); return false; }, false);
	//this.canvas.addEventListener('keydown', function(e) { e.preventDefault(); return false; }, false);
	//ajout d'une police texte
	
	
	
	try{
		var f = new FontFace("lcd", "url("+cheminTTF+"5by7.ttf)", {});
		document.fonts.add(f);	
	}
	catch(error){console.log(error)};	
	  //ajout des événements 
	
	//keypress : récupére les lettres et chiffres tapés au clavier
	document.addEventListener("keypress",function(e){
		var touche=e.key;
		if (monCanvas.selection!=null && monCanvas.selection.selectionne){
			if (touche!="Enter"){
				monCanvas.selection.touchepresse(touche);
			}
			else{
				monCanvas.canvas.style.cursor="pointer";
				monCanvas.selection.selectionne=false;
				monCanvas.selection=null;
				if (monCanvas.focus!=null){monCanvas.focus.onfocusout();monCanvas.focus=null;};
				monCanvas.actualise = false;  
			}
		}
	},true);
	//keydown : récupère les touches alphanumériques et  les autres touches
	document.addEventListener("keydown",function(e){
		var touche=e.key;
		if (monCanvas.selection!=null && monCanvas.selection.selectionne){
			monCanvas.selection.touchedown(touche);
		}		
	},true);
	//down
	this.canvas.addEventListener('mousedown', function(e) {
		//on récupère les paramètre du clic
		monCanvas.bouton=e.button;
		var pointClique ={x:Math.round(e.clientX/monCanvas.echelle),y:Math.round(e.clientY/monCanvas.echelle)};//pointXY(e);
		var mx = pointClique.x;
		var my = pointClique.y;
		var widgets = monCanvas.widgets;
		//on desélectionne tous le widgets
		for (var j = widgets.length-1; j >= 0; j--) {
			widgets[j].selectionne=false;
		}
		//on efface la mémorisation du widget sélectionné
		monCanvas.selection = null;
		monCanvas.drag=null;
		var maSelection=null;
		//monCanvas.prioritaire = null;
		//on vérifie qu'on n'a pas cliqué dans un widget
		for (var i = widgets.length-1; i >= 0; i--) {
			if (widgets[i].contient(mx, my)) {
				maSelection = widgets[i];
				//si nouveau contrôle cliqué, l'ancien perd le focus, le nouveau le gagne : on appelle les gestionnaires d'événement
				if (monCanvas.bouton==2){monCanvas.drag=maSelection;}else{monCanvas.drag=null;};
				if (monCanvas.bouton==0 && monCanvas.focus!=maSelection){
					if (monCanvas.focus!=null){monCanvas.focus.onfocusout();};
					monCanvas.focus=maSelection;
					maSelection.onfocusin();	
				}
				//mémorisation du point de drag
				monCanvas.dragOffset = {x:pointClique.x - maSelection.left, y:pointClique.y - maSelection.top};
				//if (maSelection.draggable){monCanvas.dragging = true};
				monCanvas.selection = maSelection;
				if (monCanvas.bouton==0){maSelection.selectionne=true};
				//un objet est sélectionné : on redessine pour afficher le rectangle de sélection
				monCanvas.actualise = false;
				//on appelle le gestionnaire d'événement onclick du widget sélectionné
				if (monCanvas.bouton==0) {monCanvas.selection.onclick(pointClique)};
				return;
			}
		}
		// return n'a pas été fait donc aucun widget à sélectionner n'a été trouvé.
		// dans le cas où un objet serait sélectionné, il faut le désélectionner et lancer l'événement onfocusout
		if (monCanvas.selection!=null) {
				monCanvas.selection = null; 
		}		
		if (monCanvas.focus!=null){
			monCanvas.focus.onfocusout();
			monCanvas.focus!=null
		}		
		this.style.cursor="";
		// provoquera le rafraichissement du dessin pour effacer le rectangle de sélection
		monCanvas.actualise = false;	  
		//}
	 }, true);
	//move 
	this.canvas.addEventListener('mousemove', function(e) {
		monCanvas.canvas.style.cursor="default";
		var pointOver ={x:Math.round(e.clientX/monCanvas.echelle),y:Math.round(e.clientY/monCanvas.echelle)};//pointXY(e);
		var mx = pointOver.x;
		var my = pointOver.y;
		var maSelection=null;
		if (monCanvas.selection!=null && monCanvas.selection.obj!="text"){monCanvas.selection=null};
		var widgets = monCanvas.widgets;
		for (var i = widgets.length-1; i >= 0; i--) {
			if (widgets[i].contient(mx, my)) {
				maSelection=widgets[i];
				monCanvas.selection=maSelection;
				//si passe devant un nouveau  contrôle, l'ancien perd le over, le nouveau le gagne : on appelle les gestionnaires d'événement
				if (maSelection!=null ){//&& monCanvas.over!=maSelection){
					if (monCanvas.over!=null){monCanvas.over.onout(pointOver);monCanvas.over=null};
					//on vérifie qu'on est sur la zone active d'un over qui n'est pas obligatoirement tout le widget
					if (maSelection.contientzoneover(mx,my)){
						monCanvas.over=maSelection;
						maSelection.onover(pointOver);	
					}	
				}
				//on appelle le gestion onmove du widget survolé
				if (maSelection!=null){
					monCanvas.canvas.style.cursor="pointer";maSelection.onmove(pointOver);monCanvas.actualise = false;
				}
				//on rentre dans un texte déjà sélectionné: on remet le curseur sinon curseur pas défaut
				if (widgets[i].obj=='text' && widgets[i].selectionne){monCanvas.canvas.style.cursor="text";}else{monCanvas.canvas.style.cursor="pointer";}
				return;
			}
		}
		// return n'a pas été fait donc aucun widget n'a été trouvé.
		//on effectue un onout si un over est mémorisé
		if (monCanvas.over!=null){
			monCanvas.over.onout();
			monCanvas.over=null
		}			
		
			
		//dragging
		if (monCanvas.dragging && monCanvas.bouton==2){
			var pointOver ={x:Math.round(e.clientX/monCanvas.echelle),y:Math.round(e.clientY/monCanvas.echelle)};//pointXY(e);
			if (monCanvas.drag!=null && monCanvas.drag.draggable){
			  monCanvas.drag.left = pointOver.x - monCanvas.dragOffset.x;
			  monCanvas.drag.top = pointOver.y - monCanvas.dragOffset.y;   
			  //un widget a été déplacé
			  monCanvas.actualise = false; 
			}  
		}
		
	}, true);
	//up
	this.canvas.addEventListener('mouseup', function(e) {
		//on arrête le drag and drop	
		monCanvas.drag=null;
		var pointClique ={x:Math.round(e.clientX/monCanvas.echelle),y:Math.round(e.clientY/monCanvas.echelle)};//pointXY(e);
		
		var mx = pointClique.x;
		var my = pointClique.y;
		var widgets = monCanvas.widgets;
		for (var i = widgets.length-1; i >= 0; i--) {
			if (widgets[i].contient(mx, my)) {
				widgets[i].onup();return} else{ if (widgets[i].obj!="text"){widgets[i].selectionne=false;}};
		}		
		monCanvas.selection = null;
		
		monCanvas.focus=null;
		monCanvas.actualise = false;  
		
	 }, true);
    // double click 
	this.canvas.addEventListener('dblclick', function(e) {
    var pointClique = {x:Math.round(e.clientX/monCanvas.echelle),y:Math.round(e.clientY/monCanvas.echelle)};//pointXY(e);//pointXY(e);
   //a créer
	}, true);
	//roulette souris
	this.canvas.addEventListener('wheel', function(e) { 
		if (monCanvas.selection!=null){
			
			monCanvas.selection.wheel(e.deltaY);
		}	
	},true);	
	
 
  // **** Options du rectangle de selection ! ****
  
  this.selectionColor = '#CC0000';
  this.selectionWidth = 2; 
  	
  this.interval = 30;
  setInterval(function() { monCanvas.dessine(); }, monCanvas.interval);
}
//ajout d'un widget
grafWidgets.prototype.addWidget = function(widget) {
  widget.parent=this;		
  widget.ctx=this.ctx;	
  this.widgets.push(widget);
  //un widget a été ajouter : il faut redessiner
  this.actualise = false;
}
//efface le canvas
grafWidgets.prototype.clear = function() {
  this.ctx.clearRect(0, 0, this.width, this.height);
}
//Redessine le canvas tous les intervalles si actualise à true
grafWidgets.prototype.dessine = function() {
  // if our state is inactualise, redraw and actualiseate!
  if (!this.actualise) {
    var widgets = this.widgets;
    this.clear();
    
    // on ajoute le background :fonction à surcharger
	this.ctx.save();
    this.dessinefond();
	this.ctx.restore();
   
   // dessine tous les widgets
    var l = widgets.length;
    for (var i = 0; i < widgets.length; i++) {
      var widget = widgets[i];
      // We can skip the drawing of elements that have moved off the screen:
      if (widget.left > this.width || widget.top > this.height ||
          widget.left + widget.width < 0 || widget.top + widget.height < 0) continue;
		  
      widgets[i].dessine();
    }
    // on dessine le rectangle de sélection si un composant est sélectionné et que sa propriété focus est à true
	if (this.focus!=null && this.focus.focus) {
	
      this.ctx.strokeStyle = this.selectionColor;
       this.ctx.lineWidth = this.selectionWidth;
      //var maSelection = this.focus;
       this.ctx.strokeRect(this.focus.left-2*this.selectionWidth,this.focus.top-2*this.selectionWidth,this.focus.width+4*this.selectionWidth,this.focus.height+4*this.selectionWidth);
    }
	if (this.dragging && this.drag!=null && this.drag.draggable) {
	    this.ctx.strokeStyle = this.selectionColor;
       this.ctx.lineWidth = this.selectionWidth;
      //var maSelection = this.focus;
       this.ctx.strokeRect(this.drag.left-2*this.selectionWidth,this.drag.top-2*this.selectionWidth,this.drag.width+4*this.selectionWidth,this.drag.height+4*this.selectionWidth);
    }
    
    
    // on ajoute le dessin du premier plan ici : fonction à surcharger
	this.ctx.save();
	this.dessinePP();
	this.ctx.restore();
	this.dessineC();
	this.actualise = true;
  }


}
//définition des widgets


//la classe widget de base est un rectangle
function widget(nom,left, top, width, height) {
	this.obj=null;
	this.parent=null;
	this.nom=nom||''; 	
	this.left=left||0;
	this.top=top||0;
	this.width=width||20;
	this.height=height||20;
	//pas de comportement au survol
	this.over=false;
	//pas de rectangle de sélection par défaut
	this.focus=false;
	//pas déplaçable par defaut;
	this.draggable=false;
	//selectionne
	this.selectionne=false;
	//aspect des controle
	this.realiste=true;
	//couleurs par défaut
	this.color = '#AAAAAA';
	this.bkcolor="white";
	this.outcolor='white';
	this.overcolor="black";
	this.txtcolor = "black";
	this.txtovercolor = "white";
	this.txtoutcolor = "black";
	this.shadowcolor="rgba(0,0,0,0.5)";
	this.police={false:'sans serif',true:'Arial'};
	}
widget.prototype={
	//la souris est dans le widget
	contient : function(mx, my) {
		return  (this.left <= mx) && (this.left + this.width >= mx) &&
          (this.top <= my) && (this.top + this.height >= my);
	},
	contientzoneover : function(mx, my) {
		//par defaut tout le widget réagit à over
		return  (this.left <= mx) && (this.left + this.width >= mx) &&
          (this.top <= my) && (this.top + this.height >= my);
	},
	// Dessine le widget dans le context passé en paramètre
	dessine : function() {
		with(this.ctx){
			beginPath();
			fillStyle = this.color;
			fillRect(this.left, this.top, this.width, this.height);
			closePath();
		}
	},
	onclick : function(pointClique){
	},
	onmove : function(pointOver){
	},
	onup : function(){
	},
	touchepresse:function(valeur){
	},
	touchedown:function(valeur){
	},
	onchange:function(){
	},
	onfocusin:function(){
	},
	onfocusout:function(){
	},
	wheel:function(valeur){
	},
	onover:function(){
	},
	onout:function(){
	},
	callback:function(){}
}

//tous les widgets dérivent de widget

//image cliquable
function img(nom,left,top,width,height,source,lien,titre) {
	//héritage
	widget.call(this,nom,left,top,width,height);
	this.image=new Image();
	this.image.src=source||null;
	this.lien=lien||null;
	this.titre=titre||"";
	
}	
//récupération du prototype de la classe mère
img.prototype = new widget(this.nom,this.left, this.top, this.width, this.height);
img.prototype.dessine = function(){
	this.ctx.drawImage(this.image,this.left,this.top,this.width,this.height);
	}
	
img.prototype.onover=function(){
	this.parent.canvas.title=this.titre;
}
img.prototype.onout=function(){
	this.parent.canvas.title=""
}
	

img.prototype.onclick=function(pointClique){
	if (pointClique.x>this.left && pointClique.x<this.left+this.width && pointClique.y>this.top && pointClique.y<this.top+this.height){
		if (this.lien!=null){
			window.open(this.lien,'_blank');
			}
	}
	this.callback();
}	
		
		

//case à cocher
function checked(nom,left,top,width,height,value) {
	//héritage
	widget.call(this,nom,left,top,width,height);
	this.value=value||false;
	this.memoWidth=width;
	this.memoHeight=width;
	this.chkcolor="red";
	this.obj="checked";
	this.imageon=new Image();
	this.imageon.src=cheminPNG+"interonwhite.png";
	this.imageoff=new Image();
	this.imageoff.src=cheminPNG+"interoffwhite.png";
	this.width=this.memoWidth;
	this.height=this.memoHeight;
	this.posTextUnder=false;
	this.draggable=false;
	this.taille=20;
	
}
//récupération du prototype de la classe mère
checked.prototype = new widget(this.nom,this.left, this.top, this.width, this.height);
checked.prototype.dessine = function(){
	with(this.ctx){
		//font = 'bold '+this.taille+'px sans-serif';
		font =  'Bold '+this.taille+'px '+this.police[this.realiste];
		this.largTxt=measureText(this.nom);
		if (this.posTextUnder){
			this.width=this.largTxt.width;
		}else{
			this.width=this.memoWidth+this.largTxt.width+1;
		}	
		//photo
		if (this.realiste){
			if (this.posTextUnder){	
				this.height=this.memoHeight*2+20;
				if (this.value){
					drawImage(this.imageon,this.left-this.memoWidth/2+this.width/2,this.top,this.memoWidth,this.memoHeight*2);
				}else{
					drawImage(this.imageoff,this.left-this.memoWidth/2+this.width/2,this.top,this.memoWidth,this.memoHeight*2);
				};
			}
			else{		
				this.height=this.memoHeight*2;
				if (this.value){
					drawImage(this.imageon,this.left,this.top,this.memoWidth,this.memoHeight*2);
				}else{
					drawImage(this.imageoff,this.left,this.top,this.memoWidth,this.memoHeight*2);
				};
			}
			beginPath();
				shadowOffsetX = 4;
				shadowOffsetY = 4;
				shadowBlur = 4;	
				shadowColor   = this.shadowcolor;
				fillStyle=this.txtcolor;
				if (this.posTextUnder){
					textAlign="center";
					fillText(this.nom,this.left+this.width/2,this.top+this.memoHeight*2+10);
				}
				else{
					textAlign="left";
					baseLine="vertical";
					fillText(this.nom,this.left+this.memoWidth+2,this.top+this.height/2);
				}	
				shadowOffsetX = 0;
				shadowOffsetY = 0;
				shadowBlur = 0;	
				shadowColor   = "rgba(0, 0, 0, 0)";
			closePath();
		}
		//dessin
		else{	
			beginPath();
				textAlign="left";
				beginPath();
					shadowOffsetX = 4;
					shadowOffsetY = 4;
					shadowBlur = 4;	
					shadowColor   = this.shadowcolor;
					if (this.posTextUnder){
						this.height=this.memoHeight+20;
						fillStyle=this.color;
						fillRect(this.left+this.width/2-this.memoWidth/2,this.top,this.memoWidth,this.memoWidth);
						textAlign="center";
						fillStyle=this.txtcolor;
						fillText(this.nom,this.left+this.width/2,this.top+this.memoHeight+10);
						shadowOffsetX = 0;
						shadowOffsetY = 0;
						shadowBlur = 0;	
						shadowColor   = "rgba(0, 0, 0, 0)";
						rect(this.left+this.width/2-this.memoWidth/2,this.top,this.memoWidth,this.memoWidth);
						stroke();
					}
					else{
						this.height=this.memoHeight;
						textAlign="left";
						textBaseline="middle";
						fillStyle=this.color;
						fillRect(this.left,this.top,this.memoWidth,this.memoWidth);
						fillStyle=this.txtcolor;
						fillText(this.nom,this.left+this.memoWidth+1,this.top+this.memoHeight/2);
						shadowOffsetX = 0;
						shadowOffsetY = 0;
						shadowBlur = 0;	
						shadowColor   = "rgba(0, 0, 0, 0)";
						rect(this.left,this.top,this.memoWidth,this.memoWidth);
						stroke();
					}	
					
				closePath();
				beginPath();
					fillStyle=this.chkcolor;
					shadowOffsetX = 2;
					shadowOffsetY = 4;
					shadowColor   = this.shadowcolor;
					if (this.value==1){
						if (this.posTextUnder){
							textAlign="center";
							 fillText("✔",this.left+this.width/2,this.top+this.memoHeight/2-1) ;
						}
						else{			
							textAlign="left";
							if (this.value==1) fillText("✔",this.left,this.top+this.height/2-1) ;
						}	
					}		
					shadowColor   = "rgba(0, 0, 0, 0)";
					shadowBlur = 0;	
					shadowOffsetX = 0;
					shadowOffsetY = 0;
				closePath();
			}
		}
	}
checked.prototype.onclick=function(pointClique){
	if (pointClique.x>this.left && pointClique.x<this.left+this.width && pointClique.y>this.top && pointClique.y<this.top+this.height){
		this.value=1-this.value;
	}
	this.callback();
}	

//bouton	
function button(nom,left,top,width,height) {
	//héritage
	widget.call(this,nom,left,top,width,height);
	//comportement au survol
	this.over=true;
	//la fonction a exécuter quand le bouton est pressé
	this.obj="button";
	//this.police={false:'sans serif',true:'Arial'};
	this.padding=5;
	this.memoLeft=left;
	this.autoadjust=true;
}
//récupération du prototype de la classe mère
button.prototype = new widget(this.nom,this.left, this.top, this.width, this.height);
button.prototype.dessine = function(){
	with(this.ctx){

		shadowOffsetX = 4;
		shadowOffsetY = 4;
		shadowBlur = 4;	
		shadowColor   = this.shadowcolor;	
	}
	this.redessine();

}	
button.prototype.redessine = function(){
	with(this.ctx){
		beginPath();
			font = 'Bold '+(0.67*this.height).toString()+'px '+this.police[this.realiste];
			if (this.autoadjust){this.width=measureText(this.nom).width+this.padding};
			this.left=this.memoLeft-this.width/2;
			fillStyle=this.bkcolor;
			strokeStyle=this.bkcolor;
			var r = this.left + this.width;
			var b = this.top + this.height;
			var radius=4;
			//lineWidth="4";
			moveTo(this.left+radius, this.top);
			lineTo(r-radius, this.top);
			quadraticCurveTo(r, this.top, r, this.top+radius);
			lineTo(r, this.top+this.height-radius);
			quadraticCurveTo(r, b, r-radius, b);
			lineTo(this.left+radius, b);
			quadraticCurveTo(this.left, b, this.left, b-radius);
			lineTo(this.left, this.top+radius);
			quadraticCurveTo(this.left, this.top, this.left+radius, this.top);
			fill();
			shadowOffsetX = 4;
			shadowOffsetY = 4;
			shadowBlur = 4;	
			shadowColor   = this.shadowcolor;	
			fillStyle=this.txtcolor;
			textAlign="center";
			textBaseline="middle";
			fillText(this.nom,this.left+this.width/2,this.top+this.height/2+this.height/16);
			lineWidth="1";
		closePath();
		shadowOffsetX = 0;
		shadowOffsetY = 0;
		shadowBlur = 0;	
		shadowColor   = "rgba(0, 0, 0, 0)";
		}
	}
button.prototype.onclick=function(pointClique){
	if (pointClique.x>this.left && pointClique.x<this.left+this.width && pointClique.y>this.top && pointClique.y<this.top+this.height){
		
		this.callback();
	}
}	
button.prototype.onover=function(){
this.bkcolor=this.overcolor;this.txtcolor=this.txtovercolor;//this.parent.actualise=false;
			this.redessine();
}
button.prototype.onout=function(){
this.bkcolor=this.outcolor;this.txtcolor=this.txtoutcolor;this.parent.actualise=false;
			this.redessine();
}

//class de base pour range
function range(nom,left,top,width,height,mini,maxi,value,nbDiv,nbSousDiv) {
	//héritage
	widget.call(this,nom,left,top,width,height);
	//propriétés du contrôle non modifiable par l'utilisateur
		this.obj="range";
		this.over=true;
		this.select=false;
		this.draggable=false;
		//modifiable à la création
		this.mini=mini||0;
		this.maxi=maxi||10;
		this.value=value||0;
		this.nbDiv=nbDiv||10;
		this.nbsousdiv=nbSousDiv||1;
	//correction des erreurs possibles d'initialisation
		if (this.value>this.maxi){this.value=this.maxi};
		if (this.value<this.mini){this.value=this.mini};
	//comportement autostep du contrôle
		this.autostep=true;
	//à recalculer dans les fonctions l'utilisant 
		this.step=(this.maxi-this.mini)/(this.nbDiv*this.nbsousdiv);
	//aspect du controle
		//couleur par defaut
			this.color="black";
			this.curseurcolor="white";
			this.etiquettecolor="black";
		//taille des fonts 
			this.fontAuto=true;
			this.tailfont=30;	
			this.tailfontetiq=30;
		//options d'affichage
			this.legende=true;//affiche les valeurs des graduations
			this.grad=true;//affiche les graduations
			this.sousgrad=true;//affiche les sous-graduations
			this.etiquette=true;//affiche la valeur dans le curseur
			this.fixleg=0;//nb décimale de la légende
			this.fixetiq=1;//nb décimale de l'étiquette
		//paramètres du curseur réaliste
			this.image=new Image();
			this.image.src=cheminPNG+"cursh.png";
		
}
//récupération du prototype de la classe mère
range.prototype = new widget(this.nom,this.left, this.top, this.width, this.height);
range.prototype.onup=function(){
	this.select=false;
}
range.prototype.ecris=function(valeur){
	this.value=valeur;
}
range.prototype.onout=function(pointOver){	
	this.curseurcolor=this.outcolor;
	this.etiquettecolor=this.txtoutcolor;
	this.parent.actualise=false;
}
range.prototype.onover=function(pointClique){
	this.curseurcolor=this.overcolor;
	this.etiquettecolor=this.txtovercolor;
	this.parent.actualise=false;
}
//range horizontal
function rangeH(nom,left,top,width,height,mini,maxi,value,nbDiv,nbSousDiv) {
	range.call(this,nom,left,top,width,height,mini,maxi,value,nbDiv,nbSousDiv);
	//paramètres du curseur dessiné
	this.largCurseur=40;
	this.hautCurseur=20;
	this.calculEltGraph();
}	
//récupération du prototype de la classe mère range
rangeH.prototype = new range(this.nom,this.left, this.top, this.width, this.height,this.mini,this.maxi,this.value,this.nbDiv,this.nbSousDiv);
rangeH.prototype.calculEltGraph=function(){
	//calcul de la position du curseur
	this.railLeft=this.left+this.largCurseur/2;
	this.railTop=this.top+2*this.height/3-8;
	this.railWidth=this.width-this.largCurseur;
	this.railHeight=2;
	this.cursX=this.railLeft+(this.value-this.mini)/(this.maxi-this.mini)*(this.railWidth);
	this.cursY=this.railTop+this.hautCurseur/2;
}
rangeH.prototype.contientzoneover = function(mx,my){
	return  (this.cursX-this.largCurseur/2+2 <= mx) && (this.cursX+this.largCurseur/2+2 >= mx) &&
        (this.cursY-this.hautCurseur <= my) && (this.cursY >= my);
}  
rangeH.prototype.dessine = function(){
	with(this.ctx){
		
		font = '10px '+this.police[this.realiste];//font = '10px sans-serif';
		strokeStyle=this.color;
		//fillStyle=this.canvascolor;
		shadowOffsetX = 4;
		shadowOffsetY = 4;
		shadowBlur = 4;	
		shadowColor   = this.shadowcolor;
		textAlign="center";
		textBaseline="top";
		this.calculEltGraph();
		//dessin du bord
		fillStyle=this.bkcolor;
		beginPath();
			fillRect(this.left,this.top,this.width,this.height);
			fill();
		closePath();
		//dessin du rail
		fillStyle=this.color;
		beginPath();
			fillRect(this.railLeft,this.railTop,this.railWidth,this.railHeight);
		closePath();
		if (this.sousgrad){
			beginPath();
			for (var i=0;i<this.nbDiv*this.nbsousdiv+1;i++){
				moveTo(this.railLeft+this.railWidth*i/this.nbDiv/this.nbsousdiv,this.railTop-18);
				lineTo(this.railLeft+this.railWidth*i/this.nbDiv/this.nbsousdiv,this.railTop-14);
			}
			stroke();
			closePath();
		}	
		if (this.grad){	
			beginPath();
			lineWidth="2";
			for (var i=0;i<this.nbDiv+1;i++){
				moveTo(this.railLeft+this.railWidth*i/this.nbDiv,this.railTop-18);
				lineTo(this.railLeft+this.railWidth*i/this.nbDiv,this.railTop-8);
			}
			
			stroke();
			closePath();
		}
		if (this.legende){	
			if (this.fontAuto){
				var taille=Math.min(this.railWidth/this.nbDiv,this.height);
				var tailfontAuto=this.tailfont;
				font = 'bold '+this.taillfont+'px sans-serif';
				while(measureText(this.maxi.toFixed(this.fixleg)).width>taille){
					tailfontAuto--;
					font = 'bold ' +tailfontAuto+'px sans-serif';
				}
			}else{		
				font = 'bold ' +this.tailfont+'px sans-serif';
			}	
			for (var i=1;i<this.nbDiv+2;i++){
				fillText((this.mini+(this.maxi-this.mini)/this.nbDiv*(i-1)).toFixed(this.fixleg),this.railLeft+this.railWidth*(i-1)/this.nbDiv+1,this.top);
			}
		}	
		//ecriture du nom
		textAlign="center";
		textBaseline="bottom";
		font = '15px '+this.police[this.realiste];
		fillText(this.nom,this.left+this.width/2,this.top+this.height-4);
		//dessin du curseur
		if (!this.realiste){
			beginPath();
				strokeStyle=this.color;
				textBaseline="bottom";
				font = '14px '+this.police[this.realiste];
				fillStyle=this.curseurcolor;
				moveTo(this.cursX-this.largCurseur/2+2,this.cursY);
				lineTo(this.cursX-this.largCurseur/2+2,this.cursY-this.hautCurseur);
				lineTo(this.cursX-5,this.cursY-this.hautCurseur);
				lineTo(this.cursX,this.cursY-this.hautCurseur-5);
				lineTo(this.cursX+5,this.cursY-this.hautCurseur);
				lineTo(this.cursX+this.largCurseur/2-2,this.cursY-this.hautCurseur);
				lineTo(this.cursX+this.largCurseur/2-2,this.cursY);
				lineTo(this.cursX-this.largCurseur/2+2,this.cursY);
				stroke();fill();
				if (this.etiquette){
					if (this.fontAuto){
						var taille=this.largCurseur;
						var tailfontAuto=this.tailfontetiq;
						font = 'bold '+this.taillfont+'px sans-serif';
						while(measureText(this.maxi.toFixed(this.fixetiq)).width>taille){
							tailfontAuto--;
							font = 'bold ' +tailfontAuto+'px sans-serif';
						}
					}else{		
						font = 'bold ' +this.tailfont+'px sans-serif';
					}
					fillStyle=this.etiquettecolor;
					fillText(this.value.toFixed(this.fixetiq),this.cursX,this.cursY);
				};	
			closePath();
		}else{
			drawImage(this.image,this.cursX-this.largCurseur/2,this.cursY-this.hautCurseur,this.largCurseur,this.hautCurseur);
		}
	
		shadowOffsetX = 0;
		shadowOffsetY = 0;
		shadowBlur = 0;	
		shadowColor   = "rgba(0, 0, 0, 0)";
		
	}
}
rangeH.prototype.onclick=function(pointClique){
	if (pointClique.x > this.left && pointClique.x<this.left+this.width && pointClique.y>this.top && pointClique.y<this.top+this.height){
		this.select=true;
		//on calcule la nouvelle valeur
		this.value=(pointClique.x-this.left-this.largCurseur/2)/(this.width-this.largCurseur)*(this.maxi-this.mini)+this.mini;
		if (this.autostep){
			this.step=(this.maxi-this.mini)/(this.nbDiv*this.nbsousdiv);
			//le step le plus proche est pris
			this.value=Math.round((this.value-this.mini)/this.step)*this.step+this.mini;
		}		
		if (this.value<this.mini){this.value=this.mini};
		if (this.value>this.maxi){this.value=this.maxi};
		this.cursX=this.railLeft+(this.value-this.mini)/(this.maxi-this.mini)*(this.railWidth);
		this.cursY=this.railTop+this.hautCurseur/2;
		//le curseur du range se déplace sous la souris donc on appelle le over
		this.onover(pointClique);
		this.callback();
	}
}	
rangeH.prototype.onmove=function(pointClique){
	if (this.select){
		if (pointClique.x>this.left && pointClique.x<this.left+this.width && pointClique.y>this.top && pointClique.y<this.top+this.height){
			//on calcule la nouvelle valeur
		this.value=(pointClique.x-this.left-this.largCurseur/2)/(this.width-this.largCurseur)*(this.maxi-this.mini)+this.mini;
		if (this.autostep){
			this.step=(this.maxi-this.mini)/(this.nbDiv*this.nbsousdiv);
			//le step le plus proche est pris
			this.value=Math.round((this.value-this.mini)/this.step)*this.step+this.mini;
		}	
		if (this.value<this.mini){this.value=this.mini};
		if (this.value>this.maxi){this.value=this.maxi};
		this.cursX=this.railLeft+(this.value-this.mini)/(this.maxi-this.mini)*(this.railWidth);
		this.cursY=this.railTop+this.hautCurseur/2;
		this.callback();
		}
	}
}
//range vertical
function rangeV(nom,left,top,width,height,mini,maxi,value,nbDiv,nbSousDiv) {
	range.call(this,nom,left,top,width,height,mini,maxi,value,nbDiv,nbSousDiv);
	//paramètres du curseur dessiné
	this.largCurseur=20;
	this.hautCurseur=40;
	this.calculEltGraph();
}	
//récupération du prototype de la classe mère range
rangeV.prototype = new range(this.nom,this.left, this.top, this.width, this.height,this.mini,this.maxi,this.value,this.nbDiv,this.nbSousDiv);
rangeV.prototype.calculEltGraph=function(){
	//calcul de la position du curseur
		this.railLeft=this.left+this.width/2+8;
		this.railTop=this.top+this.hautCurseur/2;
		this.railHeight=this.height-this.hautCurseur;
		this.railWidth=2;
		this.cursY=this.railTop+(this.value-this.mini)/(this.maxi-this.mini)*(this.railHeight);
		this.cursX=this.railLeft;
}
rangeV.prototype.contientzoneover = function(mx,my){
	return  (this.cursX-5 <= mx) && (this.cursX+this.largCurseur-5 >= mx) &&
        (this.cursY-this.hautCurseur/2+2 <= my) && (this.cursY+this.hautCurseur/2-2 >= my);
}
rangeV.prototype.dessine = function(){
	with(this.ctx){
	
		font = '10px '+this.police[this.realiste];
		strokeStyle=this.color;
		//fillStyle=this.canvascolor;
		
		shadowOffsetX = 4;
		shadowOffsetY = 4;
		shadowBlur = 4;	
		shadowColor   = this.shadowcolor;
		this.calculEltGraph();
		//dessin du bord
		fillStyle=this.bkcolor;
		beginPath();
			fillRect(this.left,this.top,this.width,this.height);
			fill();
		closePath();
		
		//dessin du rail
		fillStyle=this.color;
		beginPath();
			fillRect(this.railLeft,this.railTop,this.railWidth,this.railHeight);
		closePath();
		
		if (this.sousgrad){
			beginPath();
			for (var i=0;i<this.nbDiv*this.nbsousdiv+1;i++){
				moveTo(this.railLeft-18,this.railTop+this.railHeight*i/this.nbDiv/this.nbsousdiv);
				lineTo(this.railLeft-14,this.railTop+this.railHeight*i/this.nbDiv/this.nbsousdiv);
			}
			stroke();
			closePath();
		}	
		
		if (this.grad){	
			beginPath();
			lineWidth="2";
			for (var i=0;i<this.nbDiv+1;i++){
				moveTo(this.railLeft-18,this.railTop+this.railHeight*i/this.nbDiv);
				lineTo(this.railLeft-8,this.railTop+this.railHeight*i/this.nbDiv);
			}
			
			stroke();
			closePath();
		}
		if (this.legende){	
			textBaseline="middle";textAlign="left";
			if (this.fontAuto){
				var taille=Math.min(this.railHeight/this.nbDiv,this.width);
				var tailfontAuto=this.tailfont;
				font = 'bold '+this.taillfont+'px sans-serif';
				while(measureText(this.maxi.toFixed(this.fixleg)).width>taille){
					tailfontAuto--;
					font = 'bold ' +tailfontAuto+'px sans-serif';
				}
			}else{		
				font = 'bold ' +this.tailfont+'px sans-serif';
			}	
			
			for (var i=1;i<this.nbDiv+2;i++){
				fillText((this.mini+(this.maxi-this.mini)/this.nbDiv*(i-1)).toFixed(this.fixleg),this.left,this.railTop+this.railHeight*(i-1)/this.nbDiv+1);
			}
		}
		//ecriture du nom
		textAlign="center";
		textBaseline="top";
		var decal=Math.floor(this.height/(this.nom.length+2));
		font = (decal+2)+'px '+this.police[this.realiste];
		for (var i=0;i<this.nom.length;i++){
			fillText(this.nom[i],this.left+this.width-8,this.top+decal*(i+1));
		}	
		//dessin du curseur
		if (!this.realiste){
			beginPath();
				strokeStyle=this.color;
				textBaseline="bottom";
				font = '14px '+this.police[this.realiste];
				fillStyle=this.curseurcolor;
				moveTo(this.cursX+this.largCurseur-5,this.cursY-this.hautCurseur/2+2);
				lineTo(this.cursX+this.largCurseur-5,this.cursY+this.hautCurseur/2-2);
				lineTo(this.cursX-5,this.cursY+this.hautCurseur/2-2);
				lineTo(this.cursX-5,this.cursY+5);
				lineTo(this.cursX-10,this.cursY);
				lineTo(this.cursX-5,this.cursY-5);
				lineTo(this.cursX-5,this.cursY-this.hautCurseur/2+2);
				lineTo(this.cursX+this.largCurseur-5,this.cursY-this.hautCurseur/2+2);
				stroke();fill();
				if (this.etiquette){
					if (this.fontAuto){
						var taille=this.largCurseur;
						var tailfontAuto=this.tailfontetiq;
						font = 'bold '+this.taillfont+'px sans-serif';
						while(measureText(this.maxi.toFixed(this.fixetiq)).width>taille){
							tailfontAuto--;
							font = 'bold ' +tailfontAuto+'px sans-serif';
						}
					}else{		
						font = 'bold ' +this.tailfont+'px sans-serif';
					}
					textBaseline="middle";
					fillStyle=this.etiquettecolor;
					fillText(this.value.toFixed(this.fixetiq),this.cursX+this.largCurseur-13,this.cursY);
				};	
			closePath();
		}else{
			save();
			translate(this.cursX,this.cursY);
			rotate(Math.PI/2);
			drawImage(this.image,-this.hautCurseur/2,-this.largCurseur/2,this.hautCurseur,this.largCurseur);
			rotate(-Math.PI/2);
			translate(-this.cursX,-this.cursY);
			restore();
		}	
		shadowOffsetX = 0;
		shadowOffsetY = 0;
		shadowBlur = 0;	
		shadowColor   = "rgba(0, 0, 0, 0)";
		
	}
}
rangeV.prototype.onclick=function(pointClique){
	if (pointClique.x > this.left && pointClique.x<this.left+this.width && pointClique.y>this.top && pointClique.y<this.top+this.height){
		this.select=true;
		//on calcule la nouvelle valeur
		this.value=(pointClique.y-this.railTop)/this.railHeight*(this.maxi-this.mini)+this.mini;
		if (this.autostep){
			this.step=(this.maxi-this.mini)/(this.nbDiv*this.nbsousdiv);
			//le step le plus proche est pris
			this.value=Math.round((this.value-this.mini)/this.step)*this.step+this.mini;
		}		
		if (this.value<this.mini){this.value=this.mini};
		if (this.value>this.maxi){this.value=this.maxi};
		this.cursY=this.railTop+(this.value-this.mini)/(this.maxi-this.mini)*(this.railHeight);
		this.cursX=this.left+this.width/2;;
		//le curseur du range se déplace sous la souris donc on appelle le over
		this.onover(pointClique);
		this.callback();
	}
}	
rangeV.prototype.onmove=function(pointClique){
	if (this.select){
		if (pointClique.x>this.left && pointClique.x<this.left+this.width && pointClique.y>this.top && pointClique.y<this.top+this.height){
			//on calcule la nouvelle valeur
			this.value=(pointClique.y-this.railTop)/this.railHeight*(this.maxi-this.mini)+this.mini;
			if (this.autostep){
				this.step=(this.maxi-this.mini)/(this.nbDiv*this.nbsousdiv);
				//le step le plus proche est pris
				this.value=Math.round((this.value-this.mini)/this.step)*this.step+this.mini;
			}	
			if (this.value<this.mini){this.value=this.mini};
			if (this.value>this.maxi){this.value=this.maxi};
			this.cursY=this.railTop+(this.value-this.mini)/(this.maxi-this.mini)*(this.railHeight);
			this.cursX=this.left+this.width/2;;
			this.callback();
		}
	}
}	

//spinner
function spinner(nom,left,top,largeur,mini,maxi,value,bkcolor,txtcolor,leftcolor,rightcolor) {
	//héritage
	widget.call(this,nom,left,top,largeur,largeur);
	this.largeur=largeur;
	this.bkcolor=bkcolor||"black";
	this.leftcolor=leftcolor||"black";
	this.rightcolor=rightcolor||"black";
	this.txtcolor=txtcolor||"white";
	this.mini=mini||1;
	this.maxi=maxi||10;
	this.value=value||1;
	this.fontAuto=true;
	this.tailfont=30;	
	this.vertical=false;
	this.obj="spinner";
}
//récupération du prototype de la classe mère
spinner.prototype = new widget(this.nom,this.left, this.top, this.largeur);
spinner.prototype.dessine = function(){
	with(this.ctx){

		shadowOffsetX = 4;
		shadowOffsetY = 4;
		shadowBlur = 4;	
		shadowColor   = this.shadowcolor;
		if (!this.vertical){
			this.height=this.largeur;
			this.width=this.largeur*3;
			beginPath();
				fillStyle=this.leftcolor;strokeStyle=this.leftcolor;
				//dessin du triangle de gauche
				moveTo(this.left,this.top+this.height/2);
				lineTo(this.left+this.width/3-2,this.top+1);
				lineTo(this.left+this.width/3-2,this.top+this.height-1);
				lineTo(this.left,this.top+this.height/2);
				stroke();
				if (this.value>this.mini){	fill();}
			closePath();
			beginPath();	
				//dessin du rectangle de centre
				fillStyle=this.bkcolor;
				fillRect(this.left+this.width/3,this.top,this.width/3,this.height);
			closePath();
			beginPath();
				//dessin du triangle de droite
				fillStyle=this.rightcolor;
				moveTo(this.left+2*this.width/3+2,this.top+1);
				lineTo(this.left+this.width,this.top+this.height/2);
				lineTo(this.left+2*this.width/3+2,this.top+this.height-1);
				lineTo(this.left+2*this.width/3+2,this.top+1);
				stroke();
				if (this.value<this.maxi){fill()}	;
			closePath();
			beginPath();
				if (this.fontAuto){
					var taille=this.width/3;
					var tailfontAuto=this.tailfont;
					font = 'bold '+this.taillfont+'px sans-serif';
					while(measureText(this.value).width>taille){
						tailfontAuto--;
						font = 'bold ' +tailfontAuto+'px sans-serif';
					}
				}else{		
					font = 'bold ' +this.tailfont+'px sans-serif';
				};	
				fillStyle=this.txtcolor;
				textAlign="center";
				textBaseline="middle";
				fillText(this.value,this.left+this.width/2,this.top+this.height/2);
			closePath();
		}else
		//spinner vertical
		{
			this.height=this.largeur*3;
			this.width=this.largeur;
			beginPath();
				fillStyle=this.leftcolor;strokeStyle=this.leftcolor;
				//dessin du triangle de haut
				moveTo(this.left+this.width/2,this.top);
				lineTo(this.left+2,this.top+this.height/3-2);
				lineTo(this.left+this.width-2,this.top+this.height/3-2);
				lineTo(this.left+this.width/2,this.top);
				stroke();
				if (this.value<this.maxi){	fill();}
			closePath();
			beginPath();	
				//dessin du rectangle de milieu
				fillStyle=this.bkcolor;
				fillRect(this.left,this.top+this.height/3+1,this.width,this.height/3-2);
			closePath();
			beginPath();
				//dessin du triangle du bas
				fillStyle=this.rightcolor;
				moveTo(this.left+this.width/2,this.top+this.height);
				lineTo(this.left+2,this.top+2*this.height/3+2);
				lineTo(this.left+this.width-2,this.top+2*this.height/3+2);
				lineTo(this.left+this.width/2,this.top+this.height);
				stroke();
				if (this.value>this.mini){fill()}	;
			closePath();
			beginPath();
				if (this.fontAuto){
					var taille=this.width;
					var tailfontAuto=this.tailfont;
					font = 'bold '+this.taillfont+'px sans-serif';
					while(measureText(this.value).width>taille){
						tailfontAuto--;
						font = 'bold ' +tailfontAuto+'px sans-serif';
					}
				}else{		
					font = 'bold ' +this.tailfont+'px sans-serif';
				};	
				fillStyle=this.txtcolor;
				textAlign="center";
				textBaseline="middle";
				fillText(this.value,this.left+this.width/2,this.top+this.height/2);
			closePath();
		}
		shadowOffsetX = 0;
		shadowOffsetY = 0;
		shadowColor   = "rgba(0, 0, 0, 1)";
		shadowBlur = 0;	
		
	}
}
spinner.prototype.onclick=function(pointClique){
	if (pointClique.x > this.left && pointClique.x<this.left+this.width && pointClique.y>this.top && pointClique.y<this.top+this.height){
		this.select=true;
		if (!this.vertical){
			//on calcule la nouvelle valeur
			if (pointClique.x < this.left+ this.width/3){
				this.value--;
				if (this.value<this.mini){this.value=this.mini};
			}
			if (pointClique.x > this.left+ 2*this.width/3){
				this.value++;
				if (this.value>this.maxi){this.value=this.maxi};
			}
		}
		else
		{
			if (pointClique.y < this.top+ this.height/3){
				this.value++;
				if (this.value>this.maxi){this.value=this.maxi};
			}
			if (pointClique.y > this.top+ 2*this.height/3){
				this.value--;
				if (this.value<this.mini){this.value=this.mini};
			}
		}	
		this.callback();
	}
}	
spinner.prototype.onup=function(){
	this.select=false;
}
spinner.prototype.ecris=function(valeur){
	if (valeur>=this.mini && valeur<=this.maxi){
		this.value=valeur;
	}	
}

//radio
function radio(nom,left,top,width,height,puces) {
	//héritage
	widget.call(this,nom,left,top,width,height);
	this.value=0;
	this.memoWidth=width;
	this.radiocolor="red";
	this.selected=1;
	this.puces=puces;
	this.imageon=new Image();
	this.imageon.src=cheminPNG+"radioon.png";
	this.imageoff=new Image();
	this.imageoff.src=cheminPNG+"radiooff.png";
	//nb avant saut de ligne
	this.dim = 1;
	//nb de ligne (sera calculé dans dessine)
	this.ligne=1;
	this.obj="radio";
	this.draggable=false;
	this.taille=20;
	
	
	
	
}
//récupération du prototype de la classe mère
radio.prototype = new widget(this.nom,this.left, this.top, this.width, this.height);
radio.prototype.ajoutePuce-function(titre,left,top){
	//this.puces.push({titre:titre,x:left,y:top});
}
radio.prototype.dessine = function(){
	this.ctx.save();
		var curseurH=this.top;
		var nbPuces=this.puces.length;
		this.ligne = Math.ceil(nbPuces/this.dim);
		var largMax=0;
		this.ctx.font = "Bold "+(0.67*this.memoWidth).toString()+'px '+this.police[this.realiste];//this.ctx.font = 'bold 20px sans-serif';
		for (var i=0; i<nbPuces;i++){
			var longue=this.ctx.measureText(this.puces[i]).width;
			
			if (longue>largMax){largMax=longue};
		}	
		for (var i=0; i<this.ligne;i++){
			var curseurL = this.left;
			var curseurH=this.top+i*(this.memoWidth+4);
			for (var j=0;j<this.dim;j++){
				if (i*this.dim+j>nbPuces-1)break;
				with(this.ctx){
					//photo
					textAlign="left";
					textBaseline="middle";
					shadowOffsetX = 4;
					shadowOffsetY = 4;
					shadowBlur = 4;	
					shadowColor   = this.shadowcolor;
					
					if (this.realiste){
						//mode image
						beginPath();
							if (this.selected==i*this.dim+j)
								{drawImage(this.imageon,curseurL,curseurH,this.memoWidth,this.memoWidth);
							}else{
								drawImage(this.imageoff,curseurL,curseurH,this.memoWidth,this.memoWidth);
							}
							fillStyle=this.txtcolor;
							fillText(this.puces[i*this.dim+j],curseurL+this.memoWidth+3,curseurH+this.memoWidth/2);
						closePath();
					}
					//dessin
					else{	
						beginPath();
							fillStyle="white"
							arc(curseurL+this.memoWidth/2,curseurH+this.memoWidth/2,this.memoWidth/2,0,2*Math.PI);
							lineStyle="4";
							fill();
							fillStyle=this.txtcolor;
							fillText(this.puces[i*this.dim+j],curseurL+this.memoWidth+3,curseurH+this.memoWidth/2);
							strokeStyle="black";
							stroke();
						closePath();
						lineStyle="1";
						
						beginPath();		
							if (this.selected==i*this.dim+j){fillStyle="black"//}else{fillStyle="white"};
							arc(curseurL+this.memoWidth/2,curseurH+this.memoWidth/2,this.memoWidth/3,0,2*Math.PI);
							stroke();
							fill();
							}
						closePath();
					}	
					shadowOffsetX = 0;
					shadowOffsetY = 0;
					shadowBlur = 0;	
					shadowColor   = "rgba(0, 0, 0, 1)";
					curseurL=curseurL+(largMax+this.memoWidth+4);	
					
				}
			}
			
		}
		this.width=(largMax+this.memoWidth+4)*this.dim;
		this.height=this.ligne*(this.memoWidth+4);
		this.ctx.restore();
	}
radio.prototype.onclick=function(pointClique){
	if (pointClique.x>this.left && pointClique.x<this.left+this.width && pointClique.y>this.top && pointClique.y<this.top+this.height){
		var nbPuces=this.puces.length;
		var X=Math.floor((pointClique.x-this.left)/this.width*this.dim);
		var Y=Math.floor((pointClique.y-this.top)/this.height*this.ligne);
		if (Y*this.dim+X<nbPuces){this.selected=Y*this.dim+X}
	}
	this.callback();
}	

//text
function text(nom,left,top,width,height,value) {
//héritage
	widget.call(this,nom,left,top,width,height);
	this.texte=value||"";
	this.index=-1;
	this.padding=5;
	this.coefPadding=0.08; //à modifier en fonction de la photo de fond choix 
							//pour calculer le padding en fonction de la taille de l'image
	this.textPhotoColor="#35cc49";
	this.choixTextColor=this.txtcolor;
	this.selectionne=false;
	this.focus=true;
	this.obj="text";
	this.draggable=false;
	this.editable=true;
	this.image=new Image();
	this.image.src=cheminPNG+"afficheur.png";
	this.police={false:'sans serif',true:'LCD'};
	this.animation=true;
	this.indexAnim=0;
	this.monAnim=null;
	
	
}
//récupération du prototype de la classe mère
text.prototype = new widget(this.nom,this.left, this.top, this.width, this.height);
text.prototype.calculCar=function(){
		this.ctx.font = (0.50*this.height).toString()+'px '+this.police[this.realiste];
		if (this.realiste){
			//this.ctx.font = (0.50*this.height).toString()+'px lcd'
			this.realPadding=this.coefPadding*this.width;
			this.posVerText=this.top+this.height/2//+this.height/16;	
			this.choixTextColor	=this.textPhotoColor;
		}else{
			//this.ctx.font = (0.50*this.height).toString()+'px sans serif';
			this.realPadding=this.padding;
			this.posVerText=this.top+this.height/2+this.height/16;
			this.choixTextColor	= this.txtcolor;
		}	
		this.tailleCar=this.ctx.measureText(this.texte).width/this.texte.length;
		this.nbCar=Math.floor((this.width-this.realPadding*2)/this.tailleCar);
}
text.prototype.dessine=function(){
	with(this.ctx){
		
		shadowOffsetX = 4;
		shadowOffsetY = 4;
		shadowBlur = 4;	
		shadowColor   = this.shadowcolor;
		this.redessine();
			
	}
}	
text.prototype.redessine = function(){
	with(this.ctx){
		textAlign="left";
		textBaseline = "middle";
		this.calculCar();
		//type photo
		if (this.realiste){
			drawImage(this.image,this.left,this.top,this.width,this.height);
		}else
		//type dessin
		{
			fillStyle=this.color;
			fillRect(this.left,this.top,this.width,this.height);	
		}
		beginPath();
		shadowOffsetX = 4;
		shadowOffsetY = 4;
		shadowBlur = 4;	
		shadowColor   = this.shadowcolor;
		if (measureText(this.texte).width>(this.width-this.realPadding*2)){
			var memoTexte=this.texte.substring(this.indexAnim,this.nbCar+this.indexAnim);
			this.animation=true;
		}else{
			var memoTexte=this.texte;
			this.animation=false;
		}	
		var msg=memoTexte.substring(0,this.index-this.indexAnim);
		fillStyle=this.choixTextColor;
		fillText(msg,this.left+this.realPadding,this.posVerText);
		var lng=measureText(memoTexte.substring(0,this.index-this.indexAnim)).width;
		if (this.editable && this.selectionne){
			fillStyle="red";
			fillText('|',this.left+this.realPadding+lng,this.top+this.height/2);
			fillStyle=this.choixTextColor;
			lng=measureText(memoTexte.substring(0,this.index-this.indexAnim)+"|").width;
		}
		fillText(memoTexte.substring(this.index-this.indexAnim),this.left+this.realPadding+lng,this.posVerText);
		shadowOffsetX = 0;
		shadowOffsetY = 0;
		shadowBlur = 0;	
		shadowColor   = "rgba(0, 0, 0, 0)";
		closePath();
	}
}
text.prototype.onclick=function(pointClique){
	if (pointClique.x>this.left && pointClique.x<this.left+this.width && pointClique.y>this.top && pointClique.y<this.top+this.height){
		clearTimeout(this.monAnim);
		this.calculCar();
		var cursX=(pointClique.x-this.left-this.realPadding);
		var temp=Math.round(cursX/this.tailleCar)+this.indexAnim;
		if ((temp>this.index) && (this.index!=-1)){this.index=temp-1}else{this.index=temp};
		if (isNaN(this.index)){this.index=-1};
		if (this.index>this.texte.length){this.index=this.texte.length}
	}
}	
text.prototype.touchepresse=function(valeur){
	var temp=this.texte.substring(0,this.index)+valeur+this.texte.substring(this.index);
	this.texte=temp;
	this.index++;
	if (this.index>this.nbCar){this.indexAnim++;}
	//équivalent à un événement onchange
	this.callback();
	//this.parent.actualise=false;
	this.redessine();
	
}
text.prototype.touchedown=function(valeur){
	var change=false;
	switch(valeur){
		case 'Backspace' :
			this.texte=this.texte.substring(0,this.index-1)+this.texte.substring(this.index);
			if (this.indexAnim>0){this.indexAnim--;}
			if(this.index>0){this.index--};
			//équivalent à un événement onchange
			this.callback();
			//this.parent.actualise=false;
			this.redessine();
			break;
		case 'ArrowLeft' :
			if (this.indexAnim>0){this.indexAnim--;}
			if(this.index>=0){this.index--};
			//this.parent.actualise=false;
			this.redessine();
			break;	
		case 'ArrowRight' :
			if (this.index<this.texte.length){
				this.index++;	
				if (this.index>(this.nbCar)){
					this.indexAnim++;
				}	
			}
			//this.parent.actualise=false;
			this.redessine();
			break;
		case 'Home' :
			this.index=0;this.indexAnim=0;
			//this.parent.actualise=false;
			this.redessine();
			break;	
		case 'End' :
			;
			this.index=this.texte.length;this.indexAnim=this.index-this.nbCar;if(this.indexAnim<0){this.indexAnim=0};
			//this.parent.actualise=false;
			this.redessine();
			break;	
		case 'Delete' :
			this.texte=this.texte.substring(0,this.index)+this.texte.substring(this.index+1);
			change=true;
			//équivalent à un événement onchange
			this.callback();
			//this.parent.actualise=false;
			this.redessine();
			break;			
	}
	
	
}
text.prototype.onmove=function(pointOver){
		
}	
text.prototype.ecris=function(valeur){
	this.texte=valeur.toString();
	this.indexAnim=-1;
	//this.calculCar();
	//this.parent.actualise=false;
	this.redessine();
	this.anime();
}
text.prototype.animeRelance=function(){
	this.indexAnim=-1;
	this.index=-1;
	this.anime();
}
text.prototype.anime=function(){
	if (this.animation){
		clearTimeout(this.monAnim);
		font = 'Bold '+(0.67*this.height).toString()+'px '+this.police[this.realiste];
		//if (this.realiste){this.ctx.font = (0.50*this.height).toString()+'px lcd'}else{this.ctx.font = (0.50*this.height).toString()+'px sans serif'};
		var tailleCar=this.ctx.measureText(this.texte).width/this.texte.length;
		var nbCar=Math.floor((this.width-this.realPadding*2)/tailleCar);
		var nbCarRest=this.texte.length-this.indexAnim-nbCar;
		if (nbCarRest>0){this.indexAnim++;this.monAnim=setTimeout(this.anime.bind(this),500);}else{clearTimeout(this.monAnim);setTimeout(this.animeRelance.bind(this),2000);};
		//this.parent.actualise=false;;
		this.redessine();
	}	
}
text.prototype.onfocusout=function(){

	if (this.animation){this.animeRelance()};
}	

//potentiomètre
function potar(nom,left,top,width,height,angleMin,angleMax,valMin,valMax,nbGrad) {
//héritage
	widget.call(this,nom,left,top,width,height);
	this.r=Math.min(width/2,height/2);
	this.focus=false;
	this.draggable=false;
	this.image=new Image();
	this.image.src=cheminPNG+"bouton3.png";
	this.angleMin=angleMin||0;
	this.angleMax=angleMax||180;
	this.valeur=this.angleMin;
	this.nbGrad = nbGrad||6;
	this.liste=[];
	this.min=valMin||0;
	this.max=valMax||10;
	this.proportionnel=true;
	this.pas=(this.angleMax-this.angleMin)/(this.nbGrad-1);
	this.value=this.liste[this.valeur];
	this.select=false;
	this.obj="potar";
	this.precision=1;
}
//récupération du prototype de la classe mère
potar.prototype = new widget(this.nom,this.left, this.top, this.width, this.height);
potar.prototype.angle=function(pointClique){
	//calcul des coordonnées du point cliqué dans le cercle trigo en degré compris entre 0 et 360°
	var X=(pointClique.x-this.left-this.width/2)/this.r*2;
	var Y=-(pointClique.y-this.top-this.height/2)/this.r*2;
	return rev(coordpolaire(X,Y));
	
}	
potar.prototype.convertAngleValue=function(angle){
	if (this.angleMin<this.angleMax){var debut=this.angleMin,fin=this.angleMax,sens=1}else{var debut=this.angleMax,fin=this.angleMin,sens=-1};
	if (fin>=360){if (angle>=0 && angle<debut){angle=angle+360}}
	if (angle<debut){angle=debut}
	if (angle>fin){angle=fin}
	if (angle>=debut && angle<=fin){
		if (this.proportionnel){	
			this.value=Math.sign(sens)*((angle-this.angleMin)/(fin-debut)*(this.max-this.min)+this.min).toFixed(this.precision);
		}
		else{
			//il n'y a que quelques pas : le move doit être ralenti
			var temp = Math.round((angle-debut)/this.pas);
			angle=debut+temp*this.pas;
			var item=Math.abs(Math.round((angle-debut)/this.pas));
			if (sens==-1){item=this.nbGrad-1-item};
			this.value=this.liste[item];
		}
		this.valeur=angle;
		this.parent.actualise=false;
		this.callback();
	}	
}
potar.prototype.dessine=function(){
	with (this.ctx){
		
		//clearRect(this.left, this.top,this.width,this.height);
		textAlign="center";
		font = 'Bold 14px '+this.police[this.realiste];
		if (this.angleMin<this.angleMax){var debut=this.angleMin,fin=this.angleMax,sens=1}else{var debut=this.angleMax,fin=this.angleMin,sens=-1};
		beginPath();
			this.r=Math.min(this.width/2,this.height/2);
			save();
				fillStyle=this.txtcolor;strokeStyle=this.txtcolor;
				translate(this.left+this.width/2,this.top+this.height/2);
					//graduation
					for (var j=0;j<this.nbGrad;j++){
						if (sens>0){
								var i=debut+this.pas*j;
						}else{
								var i=debut-this.pas*j;
						}		
						save();
						rotate((90-i)/180*Math.PI);
						moveTo(0,-3*this.r/5);
						lineTo(0,-this.r/2);
						stroke();
						rotate((i-90)/180*Math.PI);
						restore();
					}
					//legende
					shadowOffsetX = 4;
					shadowOffsetY = 4;
					shadowBlur = 4;	
					shadowColor   = this.shadowcolor;
					if (this.proportionnel){	
						//graduation calculée
						for (var j=0;j<this.nbGrad;j++){
							if (sens>0){
							var i=debut+this.pas*j;
							}else{
							var i=debut-this.pas*j;
							}
							var texte=((i-this.angleMin)/(this.angleMax-this.angleMin)*(this.max-this.min)+this.min).toFixed(this.precision);
							fillText(texte,Math.cos(i/180*Math.PI)*4*this.r/5,-Math.sin(i/180*Math.PI)*4*this.r/5);
						}
					}	
					else{
						//graduation listée
						var index=0;
						for (var j=0;j<this.nbGrad;j++){
							if (sens>0){
								var i=debut+this.pas*j;
								}else{
								var i=debut-this.pas*j;
							}
							if (sens==1){var item=index}else{var item=this.nbGrad-1-index}
							fillText(this.liste[item],Math.cos(i/180*Math.PI)*4*this.r/5,-Math.sin(i/180*Math.PI)*4*this.r/5);
							index++;
						}
					}
					shadowOffsetX = 0;
					shadowOffsetY = 0;
					shadowBlur = 0;
				save();		
					rotate(-this.valeur/180*Math.PI);
					shadowOffsetX = 4;
					shadowOffsetY = 4;
					shadowBlur = 4;	
					shadowColor   = this.shadowcolor;
					if (this.realiste){
						drawImage(this.image,-this.r/2,-this.r/2,this.r,this.r);
					}else{
						beginPath();
							fillStyle=this.color;
							arc(0,0,this.r/2,0,2*Math.PI);
							fill();
							stroke();
						closePath();
						beginPath();
							fillStyle=this.txtcolor;
							moveTo(this.r/2,0);
							lineTo(this.r/2-10,10);
							lineTo(this.r/2-10,-10);
							lineTo(this.r/2,0);
							fill();
						closePath();
					}	
					shadowOffsetX = 0;
					shadowOffsetY = 0;
					shadowBlur = 0;	
					shadowColor   = "rgba(0, 0, 0, 0)";
					
					rotate(this.valeur/180*Math.PI);
				restore();
				translate(-this.left-this.width/2,-this.top-this.height/2);
			restore();
		closePath();
		
	}
}
potar.prototype.wheel=function(sens){
	if (this.angleMin<this.angleMax){var debut=this.angleMin,fin=this.angleMax}else{var debut=this.angleMax,fin=this.angleMin};
	if (this.proportionnel){
		var angle=this.valeur+sens/125*(this.nbGrad-1);
	}	
	else{
		var angle=this.valeur+Math.sign(sens)*(fin-debut)/(this.nbGrad-1);
	}
	this.convertAngleValue(angle);
}	
potar.prototype.touchedown=function(touche){
	if (this.angleMin<this.angleMax){var debut=this.angleMin,fin=this.angleMax,sens=1}else{var debut=this.angleMax,fin=this.angleMin,sens=-1};
	var angle=this.valeur;
	switch(touche){
		case 'ArrowLeft' :
			angle=angle-sens;
			break;	
		case 'ArrowRight' :
			angle=angle+sens;
			break;
		case 'ArrowDown' :
			angle=angle-Math.sign(sens)*this.pas;
			break;	
		case 'ArrowUp' :
			angle=angle+Math.sign(sens)*this.pas;
			break;
		case 'PageDown' :
			angle=angle-Math.sign(sens)*this.pas;
			break;	
		case 'PageUp' :
			angle=angle+Math.sign(sens)*this.pas;;
			break;	
		case 'Home' :
			if (sens==1){angle=debut}else{angle=fin};
			break;	
		case 'End' :
			if (sens==-1){angle=debut}else{angle=fin};
			break;	
	}
	this.convertAngleValue(angle);
}
potar.prototype.onclick=function(pointClique){
	if (this.parent.bouton==0){
		this.select=true;
		if (pointClique.x > this.left && pointClique.x<this.left+this.width && pointClique.y>this.top && pointClique.y<this.top+this.height){
			this.convertAngleValue(this.angle(pointClique));
		}	
	}
}
potar.prototype.onmove=function(pointClique){
	if (this.select){
		if (pointClique.x > this.left && pointClique.x<this.left+this.width && pointClique.y>this.top && pointClique.y<this.top+this.height){
			this.convertAngleValue(this.angle(pointClique));
		}
	}
}
potar.prototype.onup=function(){
	this.select=false;
}
potar.prototype.lis=function(){
	return this.value;
/*	if (this.proportionnel){
		return Math.round((this.valeur-this.angleMin)/(this.angleMax-this.angleMin)*(this.max-this.min)+this.min);
	}
	else{
		return this.liste[Math.round((this.valeur-this.angleMin)/(this.angleMax-this.angleMin)*(this.max-this.min)+this.min)];
	}*/
}	
potar.prototype.ecrisListe=function(valeur){
	if (Array.isArray(valeur)){
		this.liste=valeur;
		this.proportionnel=false;
		this.nbGrad=this.liste.length;
		this.min=this.liste[0];
		this.max=this.liste[this.nbGrad-1];
		/*if (this.min>this.max){
			var temp=this.max;
			this.max=this.min;
			this.min=temp;
		}*/
		this.pas=(this.angleMax-this.angleMin)/(this.nbGrad-1);
		this.valeur=this.angleMin;
		
	}
	else{
		console.log("erreur");
	}	
}	

//list
function list(nom,left,top,width,height) {
//héritage
	widget.call(this,nom,left,top,width,height);
	this.liste=[];
	this.choice=0;
	this.comment="Sélectionnez...";
	this.index=0;
	this.selectionne=false;
	this.focus=false;
	this.obj="list";
	this.draggable=false;
	this.deploye=false;
	this.nbLigne =3;
	this.ascenseur=0;
	this.hauteur=this.height;
	this.survol=-1;
	this.memo=this.choice;
	
}
//récupération du prototype de la classe mère
list.prototype = new widget(this.nom,this.left, this.top, this.width, this.height);
list.prototype.dessine = function(){
	with(this.ctx){
	
		shadowOffsetX = 4;
		shadowOffsetY = 4;
		shadowBlur = 4;	
		shadowColor   = this.shadowcolor;
		textAlign="left";
		font = (0.67*this.hauteur).toString()+'px '+this.police[this.realiste];
		if (this.nbLigne>this.liste.length){this.nbLigne=this.liste.length};
		if (this.nbLigne<2){this.nbLigne=2};
		if (this.ascenseur>Math.abs(this.nbLigne-this.liste.length)){this.ascenseur=Math.abs(this.nbLigne-this.liste.length)};
		fillStyle = this.color;
		strokeStyle="black";
		textBaseline="middle"; 
		if (this.deploye){this.height=this.hauteur*(this.nbLigne+1)}else{this.height=this.hauteur};
		beginPath();			
			fillRect(this.left, this.top, this.width,this.height);
			rect(this.left, this.top, this.width, this.hauteur);
			stroke();
		closePath();	
		beginPath();	
			//dessin de la flèche de deploiement
			if (this.deploye){
				moveTo(this.left+this.width-12, this.top+this.hauteur/2-9);
				lineTo(this.left+this.width-21, this.top+this.hauteur/2+9);
				lineTo(this.left+this.width-3, this.top+this.hauteur/2+9);
				lineTo(this.left+this.width-12, this.top+this.hauteur/2-9);
				stroke();
				fillStyle="black";
				if (this.nbLigne<this.liste.length){
					fillText("+",this.left+this.width-41,this.top+this.hauteur/2);
				}
				if (this.nbLigne>2){	
					fillText("-",this.left+this.width-61,this.top+this.hauteur/2);
				}	
			}else{
				moveTo(this.left+this.width-21, this.top+this.hauteur/2-9);
				lineTo(this.left+this.width-3, this.top+this.hauteur/2-9);
				lineTo(this.left+this.width-12, this.top+this.hauteur/2+9);
				lineTo(this.left+this.width-21, this.top+this.hauteur/2-9);
			}
			
			stroke();
			
		closePath();
		
		if (this.deploye){
			
			//écriture du nbLigne de la liste déployée
			beginPath();
				for (var i=1;i<this.nbLigne+1;i++){
					if (this.survol==this.ascenseur+i-1){
						fillStyle="white";
						fillRect(this.left,this.top+i*this.hauteur+1,this.width,this.hauteur-2);
						fillStyle="red";
					}else{
						fillStyle="black";
					};
					fillText(this.liste[this.ascenseur+i-1],this.left+5,this.top+i*this.hauteur+this.hauteur/2);
				}
			closePath();
			beginPath();
				//dessin de l'ascenseur si nécessaire
				if (this.nbLigne<this.liste.length){
					fillStyle="white";
					fillRect(this.left+this.width-20, this.top+this.hauteur, 20, this.height-this.hauteur-2);
					fillStyle="black";
					//fleche du haut : active si this.ascenseur>0
					moveTo(this.left+this.width-10,this.top+this.hauteur+1);
					lineTo(this.left+this.width-18,this.top+this.hauteur+19);
					lineTo(this.left+this.width-2,this.top+this.hauteur+19);
					lineTo(this.left+this.width-10,this.top+this.hauteur+1);
					stroke();
					if (this.ascenseur>0){fill()};
					closePath();
					beginPath();
					//fleche du bas : active si this.ascenseur<this.list.length-this.nbLigne
					moveTo(this.left+this.width-10,this.top+this.height-2);
					lineTo(this.left+this.width-18,this.top+this.height-19);
					lineTo(this.left+this.width-2,this.top+this.height-19);
					lineTo(this.left+this.width-10,this.top+this.height-2);
					if (this.ascenseur<this.liste.length-this.nbLigne){fill()};
					rect(this.left+this.width-20, this.top+this.hauteur, 20, this.height-this.hauteur);
				}	
				rect(this.left, this.top, this.width, this.height);
				fillStyle="black";
				stroke();
			closePath();	
		}	
		beginPath();
			fillStyle="white";
			fillText(this.liste[this.choice],this.left+5,this.top+this.hauteur/2);
			stroke();
		closePath();
		shadowOffsetX = 0;
		shadowOffsetY = 0;
		shadowBlur = 0;	
		shadowColor   = "rgba(0, 0, 0, 0)";
	
	}
}
list.prototype.onclick=function(pointClique){
	//on clique sur la flèche de déploiement
	if (pointClique.x>this.left+this.width-18 && pointClique.x<this.left+this.width-2 && pointClique.y>this.top+1 && pointClique.y<this.top+this.hauteur){
		this.deploye=!this.deploye;
	}
	//on agrandit la liste
	if (this.deploye && pointClique.x>this.left+this.width-45 && pointClique.x<this.left+this.width-31 && pointClique.y>this.top+1 && pointClique.y<this.top+this.hauteur){
		this.nbLigne++;
	}
	//on réduit la liste
	if (this.deploye && pointClique.x>this.left+this.width-65 && pointClique.x<this.left+this.width-51 && pointClique.y>this.top+1 && pointClique.y<this.top+this.hauteur){
		this.nbLigne--;
		
	}	
	//on clique sur la fléche du haut
	if (pointClique.x>this.left+this.width-18 && pointClique.x<this.left+this.width-2 && pointClique.y>this.top+this.hauteur+1 && pointClique.y<this.top+this.height-19){
		if (this.ascenseur>0){this.ascenseur--}
	}
	//on clique sur la fléche du bas
	if (pointClique.x>this.left+this.width-18 && pointClique.x<this.left+this.width-2 && pointClique.y>this.top+this.height-19 && pointClique.y<this.top+this.height-2){
		if (this.ascenseur<this.liste.length-this.nbLigne){this.ascenseur++}
	}
	//on clique sur un choix de la liste déployée
	if (pointClique.x>this.left && pointClique.x<this.left+this.width-20 && pointClique.y>this.top+this.hauteur+1 && pointClique.y<this.top+this.height){
		//on calcule le terme de la liste
		var indexChoix=Math.round((pointClique.y-this.top-this.hauteur*1.5)/((this.height-this.hauteur)/this.nbLigne));
		if (indexChoix>this.liste.length-1){indexChoix=this.liste.length-1};
		if (indexChoix<0){indexChoix=0};
		this.choice=this.ascenseur+indexChoix;
		this.deploye=false;
		this.survol=-1;
	}
	if (this.choice!=this.memo){
		this.memo=this.choice;
		this.callback();
	}	
}	
list.prototype.wheel=function(valeur){
	if (!this.deploye){
	/*	if (valeur<0 && this.ascenseur>0){
			this.ascenseur--;
			if (this.choice>0){this.choice--};
		};
		if (valeur>0 && this.ascenseur<this.liste.length-this.nbLigne){
			this.ascenseur++;
			if (this.choice<this.liste.length-1){this.choice++};
		};
	}
	else{*/
		if (valeur>0 && this.choice<this.liste.length-1){this.index++;this.choice++;this.callback();};
		if (valeur<0 && this.choice>0){this.index--;this.choice--;this.callback();};
	}
	
	this.parent.actualise = false;
	
}	
list.prototype.onmove=function(pointClique){
	if (pointClique.x>this.left && pointClique.x<this.left+this.width-20 && pointClique.y>this.top+this.hauteur+1 && pointClique.y<this.top+this.height){
		//on calcule le terme de la liste
		var indexChoix=Math.round((pointClique.y-this.top-this.hauteur*1.5)/((this.height-this.hauteur)/this.nbLigne));
		if (indexChoix>this.liste.length-1){indexChoix=this.liste.length-1};
		if (indexChoix<0){indexChoix=0};
		this.survol=indexChoix+this.ascenseur;
	}else{
		this.survol=-1
	}	
}
list.prototype.lis=function(){
	return this.liste[this.choice];
}	
